/*
 * StringReplacer.cpp
 *
 *  Created on: 2 janv. 2010
 *      Author: didier
 */


#include "StringReplacer.h"

#include <Core/Core.h>
#include <plugin/pcre/Pcre.h>
#include <plugin/pcre/lib/pcre.h>

#include <Functions4U/Functions4U.h>

using namespace Upp;

namespace ReportParser
{

	StringReplacer::StringReplacer()
	{
	}

	StringReplacer::~StringReplacer()
	{
	}

	void StringReplacer::addReplacement(ReportGenerator::InternalStringType label, ReportGenerator::InternalStringType value)
	{
		map.insert(std::make_pair(label, value));
	}

	ReportGenerator::InternalStringType StringReplacer::processText( const ReportGenerator::InternalStringType& templat )
	{
		String result = templat.c_str();
		MapType::iterator iter = map.begin();
		const MapType::iterator end = map.end();

		String label;
		String value;
		while(iter != end)
		{
			// process each label to substitute
			label = (*iter).first.c_str();
			value = (*iter).second.c_str();
			while ( result.Find(label) >= 0)
				{
					result = Replace(result, label, value);
				}
			++iter;
		}
		return result;
	}

    void StringReplacer::reset()
    {
    	map.clear();
    }
}
